/*
 *  main.cc
 *  Image Decoder test rig
 */

#include <stdio.h>
#include <string.h>

#include "Newton/Objects.h"

extern "C"
{
Ref	DecodeGIF(RefArg rcvr, RefArg inData, RefArg inStore);
Ref	DecodeJPEG(RefArg rcvr, RefArg inData, RefArg inStore);
Ref	DecodeTIFF(RefArg rcvr, RefArg inData, RefArg inStore);
Ref	DecodePNG(RefArg rcvr, RefArg inData, RefArg inStore);
}


int
main(int argc, const char * argv[])
{
	char * suffix;
	fpos_t length;

// Open the image file and create a binary object with it
	FILE * f = fopen(argv[1], "rb");
	fseek(f, 0, SEEK_END);
	fgetpos(f, &length);
	fseek(f, 0, SEEK_SET);
	RefVar data(AllocateBinary(SYM(jpeg), length));
	fread(BinaryData(data), 1, length, f);
	fclose(f);

	suffix = strrchr(argv[1], '.');
	if (suffix)
	{
		if (strcmp(suffix, ".gif") == 0)
			DecodeGIF(NILREF, data, NILREF);
		else if (strcmp(suffix, ".jpg") == 0)
			DecodeJPEG(NILREF, data, NILREF);
		else if (strcmp(suffix, ".tif") == 0)
			DecodeTIFF(NILREF, data, NILREF);
		else if (strcmp(suffix, ".png") == 0)
			DecodePNG(NILREF, data, NILREF);
	}

	return 0;
}
